#include <stdio.h>
#include <iostream.h>
#include "dllclass2.h"

DllClassDerived::DllClassDerived (int i) : i_(i) { 
  printf ("DLL routine %s\n", __PRETTY_FUNCTION__);
}

DllClassDerived::~DllClassDerived () { 
  printf ("DLL routine %s\n", __PRETTY_FUNCTION__);
}

int 
DllClassDerived::virtual_method () const 
{
  printf ("DLL routine %s\n", __PRETTY_FUNCTION__);
  return i_ * i_ * i_ * i_; 
}

int 
DllClassDerived::non_virtual_method () const 
{
  cerr << "DLL method: " << __PRETTY_FUNCTION__ << endl;
  return i_ * i_ * i_;
}

DLLIMPORT DllClassDerived* new_dllclass_derived (int i) {
  return new DllClassDerived (i);
}

DLLIMPORT int non_virtual_method_derived (const DllClassDerived* dllclass_derived) {
  return dllclass_derived->non_virtual_method ();
}

